library GMV_VitalsViewEnterRD;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  Dialogs,
  Forms,
  frmPatientVitals in '..\VitalsView\frmPatientVitals.pas' {frmVitals},
  fGMV_ShowSingleVital in '..\VitalsView\fGMV_ShowSingleVital.pas' {frmGMV_ShowSingleVital},
  fGMV_DateRange in '..\VitalsCommon\fGMV_DateRange.pas' {frmGMV_DateRange},
  uGMV_GlobalVars in '..\VitalsUtils\uGMV_GlobalVars.pas',
  uGMV_Const in '..\VitalsUtils\uGMV_Const.pas',
  uGMV_User in '..\VitalsCommon\uGMV_User.pas',
  uGMV_FileEntry in '..\VitalsCommon\uGMV_FileEntry.pas',
  uGMV_Utils in '..\VitalsUtils\uGMV_Utils.pas',
  fGMV_InputLite in '..\VitalsDataEntry\fGMV_InputLite.pas' {frmGMV_InputLite},
  uGMV_Template in '..\VitalsDataEntry\uGMV_Template.pas',
  mGMV_InputOne2 in '..\VitalsDataEntry\mGMV_InputOne2.pas' {fraGMV_InputOne2: TFrame},
  fGMV_SupO2 in '..\VitalsDataEntry\fGMV_SupO2.pas' {frmGMV_SupO2},
  fGMV_Qualifiers in '..\VitalsDataEntry\fGMV_Qualifiers.pas' {frmGMV_Qualifiers},
  uGMV_QualifyBox in '..\VitalsDataEntry\uGMV_QualifyBox.pas',
  fGMV_HospitalSelector in '..\VitalsDataEntry\fGMV_HospitalSelector.pas' {frmGMV_HospitalSelector},
  uGMV_SaveRestore in '..\VitalsCommon\uGMV_SaveRestore.pas',
  frmGMV_DateTime in '..\VitalsDateTime\frmGMV_DateTime.pas' {fGMV_DateTime},
  fGMV_PtSelect in '..\VitalsPatient\fGMV_PtSelect.pas' {frmGMV_PtSelect},
  uGMV_VitalTypes in '..\VitalsCommon\uGMV_VitalTypes.pas',
  uGMV_Patient in '..\VitalsCommon\uGMV_Patient.pas',
  mGMV_MDateTime in '..\VitalsCommon\mGMV_MDateTime.pas',
  uGMV_Common in '..\VitalsUtils\uGMV_Common.pas',
  mGMV_GridGraph in '..\VitalsView\mGMV_GridGraph.pas' {fraGMV_GridGraph: TFrame},
  uGMV_VersionInfo in '..\VitalsUtils\uGMV_VersionInfo.pas',
  uVHA_ATE740X in '..\CASMED\uVHA_ATE740X.pas',
  RS232 in '..\CASMED\RS232.pas',
  fGMV_InputTemp in '..\VitalsDataEntry\fGMV_InputTemp.pas' {frmGMV_InputTemp},
  uGMV_Engine in '..\VitalsUtils\uGMV_Engine.pas',
  uGMV_EXEVersion in '..\VitalsUtils\uGMV_EXEVersion.pas',
  uGMV_Setup in '..\VitalsCommon\uGMV_Setup.pas',
  uHEVDR_Redirector in 'uHEVDR_Redirector.pas',
  uHEVDR_pCall in 'uHEVDR_pCall.pas',
  fGMV_PtInfo in '..\VitalsPatient\fGMV_PtInfo.pas' {fraGMV_PatientInfo},
  fGMV_Info in '..\VitalsView\fGMV_Info.pas' {frmGMV_Info};

////////////////////////////////////////////////////////////////////////////////

function VitalsEnterDLG(
        const aBroker:THEVDRedirector;
        aPatient,
        aLocation,
        aTemplate,
        aSignature:String;
        aDateTime:TDateTime;
        aPatientName,
        aPatientInfo:String): Integer; export; stdcall;
begin
  Result := -1;
  try
      RPCBroker := aBroker;
      Result := VitalsInputDLG(
        aPatient,
        aLocation,
        aTemplate,
        aSignature,
        aDateTime,
        aPatientName,
        aPatientInfo
        );
  except
  end;
end;

////////////////////////////////////////////////////////////////////////////////

function VitalsViewForm(
        const aBroker:THEVDRedirector;
        aDFN,
        aLocation,
        DateStart,
        DateStop,
        aSignature,
        aContextIn,
        aContextOut,
        aName,
        anInfo,
        aHospitalName: String):TfrmVitals;export;stdcall;
begin
  RPCBroker := aBroker;
  result := getVitalsForm(
                aDFN, aLocation, DateStart, DateStop,
                aSignature,
                aName,anInfo,aHospitalName);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function VitalsEnterForm(
        const aBroker:THEVDRedirector;
        aDFN,
        aLocation,
        aTemplate,
        aSignature: String;
        aDateTime:TDateTime):TfrmGMV_InputLite;export;stdcall;
begin
  RPCBroker := aBroker;
  result := VitalsInputForm(
                aDFN, aLocation, aTemplate,
                aSignature
                ,aDateTime);
end;


function LatestVitalsList(
        const aBroker:THEVDRedirector;
        aPatient,
        aDelim:String;
        bSilent:Boolean):TStringList;export;stdcall;
begin
  RPCBroker := aBroker;
  Result := GetLatestVitals(aPatient,aDelim,bSilent);
end;

////////////////////////////////////////////////////////////////////////////////
(*
function VitalsTemplateForm(
  const aBroker:THEVDRedirector;
  aPatient,
  aLocation,
  aSignature,
  aTemplate:String;
  aNow:TDateTime):TfrmGMV_InputTemp;export;stdcall;
begin
  RPCBroker := aBroker;
  RESULT := GetVitalsInputForm({aBroker,}aPatient,aLocation,aSignature,aTemplate,aNow);
end;
*)
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function VitalsViewDLG(
        const aBroker:THEVDRedirector;
        aDFN,
        aLocation,
        DateStart,
        DateStop,
        aSignature,
        aContextIn,
        aContextOut,
        aName,
        anInfo,
        aHospitalName: String):Integer;export;stdcall;
begin
  RPCBroker := aBroker;
  if (aContextIn <> '') and not CreateContext(aContextIn) then
    begin
      MessageDLG('You do not have the <'+aContextIn + 'options'+#13+
        'Please contact IRMS',mtError,[mbOK],0);
      Result := -1;
      Exit;
    end
  else
    begin
      Result := ProcessInPatientVitals(aDFN,aLocation, DateStart, DateStop,aSignature,aName,anInfo,aHospitalName);
      if (aContextOut <> '') and not aBroker.CreateContext(aContextOut) then
        begin
          MessageDLG('You do not have the <'+aContextOut + 'options'+#13+
            'Please contact IRMS',mtError,[mbOK],0);
          Result := -2;
        end;
    end;
end;

////////////////////////////////////////////////////////////////////////////////

exports
   VitalsEnterDLG       name 'GMV_VitalsEnterDLG'   // VitalsInputDLG  - fGMV_InputLite
  ,VitalsViewDLG        name 'GMV_VitalsViewDLG'    // ProcessInPatientVitals - frmPatientVitals
  ,VitalsEnterForm      name 'GMV_VitalsEnterForm'  // VitalsInputForm  - fGMV_InputLite
//  ,VitalsTemplateForm   name 'GMV_VitalsTemplateForm'  // getVitalsInputForm - fGMV_InputTemp
  ,VitalsViewForm       name 'GMV_VitalsViewForm'   // InPatientVitalsForm - frmPatientVitals
  ,LatestVitalsList     name 'GMV_LatestVitalsList'    // GetLatestVitals - fGMV_InputLite
  ;

{$R *.res}

begin
end.
